/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: serial.h 837 2012-12-26 15:09:59Z ertl-hiro $
 */

/*
 *		ꥢ륤󥿥եɥ饤
 */

#ifndef TOPPERS_SERIAL_H
#define TOPPERS_SERIAL_H

#ifdef __cplusplus
extern "C" {
#endif

#include <extsvc_fncode.h>
#include "target_syssvc.h"

/*
 *  ꥢ륤󥿥եɥ饤ФγĥӥΥå
 */ 
#ifndef SSZ_SERIAL_OPN_POR
#define SSZ_SERIAL_OPN_POR	1024
#endif /* SSZ_SERIAL_OPN_POR */

#ifndef SSZ_SERIAL_CLS_POR
#define SSZ_SERIAL_CLS_POR	1024
#endif /* SSZ_SERIAL_CLS_POR */

#ifndef SSZ_SERIAL_REA_DAT
#define SSZ_SERIAL_REA_DAT	1024
#endif /* SSZ_SERIAL_REA_DAT */

#ifndef SSZ_SERIAL_WRI_DAT
#define SSZ_SERIAL_WRI_DAT	1024
#endif /* SSZ_SERIAL_WRI_DAT */

#ifndef SSZ_SERIAL_CTL_POR
#define SSZ_SERIAL_CTL_POR	1024
#endif /* SSZ_SERIAL_CTL_POR */

#ifndef SSZ_SERIAL_REF_POR
#define SSZ_SERIAL_REF_POR	1024
#endif /* SSZ_SERIAL_REF_POR */

/*
 *  ꥢ륤󥿥եɥ饤ФѤѥå
 */
typedef struct {
	uint_t		reacnt;			/* Хåեʸ */
	uint_t		wricnt;			/* Хåեʸ */
} T_SERIAL_RPOR;

/*
 *  ꥢ륤󥿥եɥ饤Фν롼
 */
extern void		serial_initialize(intptr_t exinf) throw();

/*
 *  ꥢ륤󥿥եɥ饤Ф̤ʸμФ
 */
extern bool_t	serial_get_chr(ID portid, char *p_c) throw();

/*
 *  ꥢ륤󥿥եɥ饤ФγĥӥˤƽФ
 *  ե
 */
#ifndef TOPPERS_SVC_CALL

Inline ER
serial_opn_por(ID portid)
{
	return((ER) cal_svc(TFN_SERIAL_OPN_POR, (intptr_t) portid, 0, 0, 0, 0));
}

Inline ER
serial_cls_por(ID portid)
{
	return((ER) cal_svc(TFN_SERIAL_CLS_POR, (intptr_t) portid, 0, 0, 0, 0));
}

Inline ER_UINT
serial_rea_dat(ID portid, char *buf, uint_t len)
{
	return(cal_svc(TFN_SERIAL_REA_DAT, (intptr_t) portid, (intptr_t) buf,
													(intptr_t) len, 0, 0));
}

Inline ER_UINT
serial_wri_dat(ID portid, const char *buf, uint_t len)
{
	return(cal_svc(TFN_SERIAL_WRI_DAT, (intptr_t) portid, (intptr_t) buf,
													(intptr_t) len, 0, 0));
}

Inline ER
serial_ctl_por(ID portid, uint_t ioctl)
{
	return((ER) cal_svc(TFN_SERIAL_CTL_POR, (intptr_t) portid,
												(intptr_t) ioctl, 0, 0, 0));
}

Inline ER
serial_ref_por(ID portid, T_SERIAL_RPOR *pk_rpor)
{
	return((ER) cal_svc(TFN_SERIAL_REF_POR, (intptr_t) portid,
											(intptr_t) pk_rpor, 0, 0, 0));
}

#endif /* TOPPERS_SVC_CALL */

/*
 *  ꥢ륤󥿥եɥ饤ФδؿƽФˤƽФ󥿥ե
 *  
 */
extern ER		_serial_serial_opn_por(ID portid) throw();
extern ER		_serial_serial_cls_por(ID portid) throw();
extern ER_UINT	_serial_serial_rea_dat(ID portid, char *buf,
													uint_t len) throw();
extern ER_UINT	_serial_serial_wri_dat(ID portid, const char *buf,
													uint_t len) throw();
extern ER		_serial_serial_ctl_por(ID portid, uint_t ioctl) throw();
extern ER		_serial_serial_ref_por(ID portid,
										T_SERIAL_RPOR *pk_rpor) throw();

#ifdef TOPPERS_SVC_CALL
#define serial_opn_por	_serial_serial_opn_por
#define serial_cls_por	_serial_serial_cls_por
#define serial_rea_dat	_serial_serial_rea_dat
#define serial_wri_dat	_serial_serial_wri_dat
#define serial_ctl_por	_serial_serial_ctl_por
#define serial_ref_por	_serial_serial_ref_por
#endif /* TOPPERS_SVC_CALL */

/*
 *  ꥢ륤󥿥եɥ饤ФĥӥȤϿ뤿
 *  
 */
extern ER_UINT	extsvc_serial_opn_por(intptr_t portid, intptr_t par2,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_serial_cls_por(intptr_t portid, intptr_t par2,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_serial_rea_dat(intptr_t portid, intptr_t buf,
									intptr_t len, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_serial_wri_dat(intptr_t portid, intptr_t buf,
									intptr_t len, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_serial_ctl_por(intptr_t portid, intptr_t ioctl,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_serial_ref_por(intptr_t portid, intptr_t pk_rpor,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();

/*
 *  ꥢ륤󥿥եɥ饤ФưѤΤ
 *
 *  ʲϡӥå¤ȤäѤ롥
 */
#define	IOCTL_NULL	0U			/* ʤ */
#define	IOCTL_ECHO	0x0001U		/* ʸ򥨥Хå */
#define	IOCTL_CRLF	0x0010U		/* LFCRղ */
#define	IOCTL_FCSND	0x0100U		/* ФƥեԤ */
#define	IOCTL_FCANY	0x0200U		/* ɤΤ褦ʸǤƳ */
#define	IOCTL_FCRCV	0x0400U		/* ФƥեԤ */

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_SERIAL_H */
